

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.interpolation.eep &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.interpolation.eep</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.interpolation.eep</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">numpy</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">scipy.interpolate</span> <span class="kn">import</span> <span class="n">pchip</span>

<span class="c1">#suggested lists of EEPs</span>
<span class="n">ZAMSlo</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;ZAMS&#39;</span><span class="p">,</span><span class="s1">&#39;IAMS&#39;</span><span class="p">,</span><span class="s1">&#39;TAMS&#39;</span><span class="p">,</span><span class="s1">&#39;TRGB&#39;</span><span class="p">,</span><span class="s1">&#39;ZACHEB&#39;</span><span class="p">,</span><span class="s1">&#39;TACHEB&#39;</span><span class="p">]</span>
<span class="n">ZAMShi</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;ZAMS&#39;</span><span class="p">,</span><span class="s1">&#39;IAMS&#39;</span><span class="p">,</span><span class="s1">&#39;TAMS&#39;</span><span class="p">,</span><span class="s1">&#39;ZACHEB&#39;</span><span class="p">,</span><span class="s1">&#39;TACHEB&#39;</span><span class="p">,</span><span class="s1">&#39;CBURN&#39;</span><span class="p">]</span>
<span class="n">HeZAMS</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;ZACHEB&#39;</span><span class="p">,</span><span class="s1">&#39;TACHEB&#39;</span><span class="p">,</span><span class="s1">&#39;CBURN&#39;</span><span class="p">]</span>


<span class="c1">#class which converts a MESA history file into an EEP track</span>
<div class="viewcode-block" id="EEP"><a class="viewcode-back" href="../../../api/posydon.interpolation.eep.html#posydon.interpolation.eep.EEP">[docs]</a><span class="k">class</span> <span class="nc">EEP</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot; Convert a MESA history file to Equivalent Evolutionary Phase (EEP) track &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">filename</span><span class="p">,</span><span class="n">EEP_NAMES</span><span class="o">=</span><span class="n">ZAMShi</span><span class="p">,</span><span class="n">EEP_INTERVAL</span><span class="o">=</span><span class="mi">100</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">filename</span> <span class="o">=</span> <span class="n">filename</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">filename</span><span class="p">,</span><span class="s1">&#39;r&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">header1</span><span class="o">=</span><span class="n">f</span><span class="o">.</span><span class="n">readline</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">header2</span><span class="o">=</span><span class="n">f</span><span class="o">.</span><span class="n">readline</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">header3</span><span class="o">=</span><span class="n">f</span><span class="o">.</span><span class="n">readline</span><span class="p">()</span>
            <span class="n">tr</span><span class="o">=</span><span class="n">genfromtxt</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">filename</span><span class="p">,</span><span class="n">names</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span><span class="n">skip_header</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
            <span class="n">names</span><span class="o">=</span><span class="n">tr</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">names</span>   
        <span class="k">except</span> <span class="ne">IOError</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Failed to open: &quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">filename</span><span class="p">)</span>

        <span class="c1">#this section attempts to find each of the EEPs for the track</span>
        <span class="n">prems</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_PreMS</span><span class="p">(</span><span class="n">tr</span><span class="p">)</span>
        <span class="n">zams</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_ZAMS</span><span class="p">(</span><span class="n">tr</span><span class="p">)</span>
        <span class="n">iams</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_IAMS</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">Xc</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">zams</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">tams</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_TAMS</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">iams</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">trgb</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_TRGB</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">tams</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">zacheb</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_ZACHEB</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">trgb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">tacheb</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_TACHEB</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">zacheb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">tpagb</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_TPAGB</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">tacheb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">pagb</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_PAGB</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">tpagb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">wdcs</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_WDCS</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">pagb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">cburn</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_CBurn</span><span class="p">(</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="n">zacheb</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>

        <span class="c1">#compute the distance metric along the track that is used to assign secondary EEPs</span>
        <span class="n">metric</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_metric_function</span><span class="p">(</span><span class="n">tr</span><span class="p">)</span>

        <span class="n">eep_index</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="c1">#if the EEP is in the input list, and it exists (&gt;0) then add it to the official list of EEPs</span>
        <span class="k">for</span> <span class="n">eep</span> <span class="ow">in</span> <span class="n">EEP_NAMES</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;PreMS&#39;</span>  <span class="ow">and</span> <span class="n">prems</span> <span class="o">&gt;=</span> <span class="mi">0</span> <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">prems</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;ZAMS&#39;</span>   <span class="ow">and</span> <span class="n">zams</span> <span class="o">&gt;=</span> <span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">zams</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;IAMS&#39;</span>   <span class="ow">and</span> <span class="n">iams</span> <span class="o">&gt;=</span> <span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">iams</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;TAMS&#39;</span>   <span class="ow">and</span> <span class="n">tams</span> <span class="o">&gt;=</span> <span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tams</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;TRGB&#39;</span>   <span class="ow">and</span> <span class="n">trgb</span> <span class="o">&gt;=</span> <span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">trgb</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;ZACHEB&#39;</span> <span class="ow">and</span> <span class="n">zacheb</span> <span class="o">&gt;=</span><span class="mi">0</span> <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">zacheb</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;TACHEB&#39;</span> <span class="ow">and</span> <span class="n">tacheb</span> <span class="o">&gt;=</span><span class="mi">0</span> <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tacheb</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;TPAGB&#39;</span>  <span class="ow">and</span> <span class="n">tpagb</span> <span class="o">&gt;=</span><span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tpagb</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;PAGB&#39;</span>   <span class="ow">and</span> <span class="n">pagb</span> <span class="o">&gt;=</span><span class="mi">0</span>   <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">pagb</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;WDCS&#39;</span>   <span class="ow">and</span> <span class="n">wdcs</span> <span class="o">&gt;=</span><span class="mi">0</span>   <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">wdcs</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">eep</span> <span class="o">==</span> <span class="s1">&#39;CBURN&#39;</span>  <span class="ow">and</span> <span class="n">cburn</span> <span class="o">&gt;=</span><span class="mi">0</span>  <span class="p">:</span> <span class="n">eep_index</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cburn</span><span class="p">)</span>

        <span class="c1">#some bookkeeping</span>
        <span class="n">eep_counter</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">num_primary</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">eep_index</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">num_secondary</span> <span class="o">=</span> <span class="n">EEP_INTERVAL</span><span class="o">*</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">eep_index</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">num_eeps</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">num_primary</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">num_secondary</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">eeps</span> <span class="o">=</span> <span class="n">zeros</span><span class="p">(</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">num_eeps</span><span class="p">),</span> <span class="n">tr</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">descr</span><span class="p">)</span>

        <span class="c1">#print(eep_index)</span>

        <span class="c1">#assign the primary EEPs in the correct location for the EEP track</span>
        <span class="k">for</span> <span class="n">eep</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">num_primary</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="n">eep_counter</span><span class="p">]</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="n">eep_index</span><span class="p">[</span><span class="n">eep</span><span class="p">]]</span>
            <span class="n">eep_counter</span> <span class="o">+=</span> <span class="n">EEP_INTERVAL</span> <span class="o">+</span> <span class="mi">1</span>

        <span class="c1">#assign the secondary EEPs in the correct location for the EEP track</span>
        <span class="k">for</span> <span class="n">eep</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">num_primary</span><span class="p">):</span>
            <span class="n">eep_counter</span> <span class="o">=</span> <span class="p">(</span><span class="n">eep</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span><span class="o">*</span><span class="p">(</span><span class="n">EEP_INTERVAL</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>
            <span class="c1"># fill in secondary</span>
            <span class="n">lo</span><span class="o">=</span><span class="n">eep_index</span><span class="p">[</span><span class="n">eep</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">hi</span><span class="o">=</span><span class="n">eep_index</span><span class="p">[</span><span class="n">eep</span><span class="p">]</span>
            <span class="n">dm</span> <span class="o">=</span> <span class="p">(</span><span class="n">metric</span><span class="p">[</span><span class="n">hi</span><span class="p">]</span> <span class="o">-</span> <span class="n">metric</span><span class="p">[</span><span class="n">lo</span><span class="p">])</span><span class="o">/</span><span class="p">(</span><span class="n">EEP_INTERVAL</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span>
            <span class="n">m</span> <span class="o">=</span> <span class="n">metric</span><span class="p">[</span><span class="n">lo</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>
            <span class="n">x</span><span class="o">=</span><span class="n">metric</span><span class="p">[</span><span class="n">lo</span><span class="p">:</span><span class="n">hi</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="n">EEP_INTERVAL</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
                <span class="n">m</span> <span class="o">+=</span> <span class="n">dm</span>
                <span class="n">y</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">name</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">names</span><span class="p">):</span>
                    <span class="n">y</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">pchip</span><span class="p">(</span><span class="n">x</span><span class="o">=</span><span class="n">metric</span><span class="p">[</span><span class="n">lo</span><span class="p">:</span><span class="n">hi</span><span class="p">],</span><span class="n">y</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="n">name</span><span class="p">][</span><span class="n">lo</span><span class="p">:</span><span class="n">hi</span><span class="p">])(</span><span class="n">m</span><span class="p">))</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="n">eep_counter</span> <span class="o">+</span> <span class="n">j</span><span class="p">]</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">y</span><span class="p">)</span>
            
    <span class="c1">#the following function definitions are for primary EEP determinations</span>
    <span class="k">def</span> <span class="nf">_PreMS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">Dfrac</span><span class="o">=</span><span class="mf">0.01</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">PreMS</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h2&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Dfrac</span><span class="o">*</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h2&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">]:</span>
                <span class="n">PreMS</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">PreMS</span>

    <span class="k">def</span> <span class="nf">_ZAMS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">dXc</span><span class="o">=</span><span class="mf">0.001</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">ZAMS</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span> 
            <span class="k">if</span> <span class="nb">abs</span><span class="p">(</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h1&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h1&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span> <span class="o">&gt;</span> <span class="n">dXc</span><span class="p">:</span> 
                <span class="n">ZAMS</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">ZAMS</span>

    <span class="k">def</span> <span class="nf">_IAMS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">Xc</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">IAMS</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span> 
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h1&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Xc</span><span class="p">:</span> 
                <span class="n">IAMS</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">IAMS</span>

    <span class="k">def</span> <span class="nf">_TAMS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">Xc</span><span class="o">=</span><span class="mf">0.00001</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">TAMS</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span> 
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h1&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Xc</span><span class="p">:</span> 
                <span class="n">TAMS</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">TAMS</span>

    <span class="k">def</span> <span class="nf">_TRGB</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">Yc_min</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">guess</span><span class="p">]</span> <span class="o">-</span> <span class="mf">0.01</span>
        <span class="n">L_He_max</span><span class="o">=-</span><span class="mf">99.</span>
        <span class="n">Tc_min</span><span class="o">=</span><span class="mf">99.</span>
        <span class="n">TRGB</span><span class="o">=-</span><span class="mi">1</span>
        <span class="n">TRGB1</span><span class="o">=</span><span class="mi">0</span>
        <span class="n">TRGB2</span><span class="o">=</span><span class="mi">0</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">Yc_min</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_LHe&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">L_He_max</span><span class="p">:</span>
                    <span class="n">L_He_max</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_LHe&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
                    <span class="n">TRGB1</span><span class="o">=</span><span class="n">i</span>
                <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Tc_min</span><span class="p">:</span>
                    <span class="n">Tc_min</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
                    <span class="n">TRGB2</span><span class="o">=</span><span class="n">i</span>
        <span class="k">return</span> <span class="nb">max</span><span class="p">(</span><span class="n">TRGB</span><span class="p">,</span><span class="nb">min</span><span class="p">(</span><span class="n">TRGB1</span><span class="p">,</span><span class="n">TRGB2</span><span class="p">))</span>

    <span class="k">def</span> <span class="nf">_ZACHEB</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">ZACHEB</span><span class="o">=-</span><span class="mi">1</span>
        <span class="n">Yc_min</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="mf">0.9</span><span class="p">,</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">guess</span><span class="p">]</span> <span class="o">-</span> <span class="mf">0.03</span><span class="p">)</span>
        <span class="n">L_He_max</span> <span class="o">=</span> <span class="o">-</span><span class="mf">99.</span>
        <span class="n">Tc_min</span> <span class="o">=</span> <span class="mf">99.</span>
        <span class="n">ZACHEB1</span><span class="o">=</span><span class="mi">0</span>
        <span class="n">ZACHEB</span><span class="o">=</span><span class="mi">0</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">Yc_min</span> <span class="ow">and</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_LHe&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">L_He_max</span><span class="p">:</span>
                <span class="n">L_He_max</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_LHe&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
                <span class="n">ZACHEB1</span><span class="o">=</span><span class="n">i</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">ZACHEB1</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">Yc_min</span> <span class="ow">and</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Tc_min</span><span class="p">:</span>
                <span class="n">Tc_min</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
                <span class="n">ZACHEB</span><span class="o">=</span><span class="n">i</span>
        <span class="k">return</span> <span class="n">ZACHEB</span>

    <span class="k">def</span> <span class="nf">_TACHEB</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">Yc_min</span><span class="o">=</span><span class="mf">0.001</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">TACHEB</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Yc_min</span><span class="p">:</span>
                <span class="n">TACHEB</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">TACHEB</span>

    <span class="k">def</span> <span class="nf">_TPAGB</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">TPAGB</span><span class="o">=-</span><span class="mi">1</span>
        <span class="n">He_shell_min</span> <span class="o">=</span> <span class="mf">0.1</span>
        <span class="n">Yc_min</span> <span class="o">=</span> <span class="mf">1.0e-6</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="n">He_shell_mass</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;he_core_mass&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">-</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;c_core_mass&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">Yc_min</span> <span class="ow">and</span> <span class="n">He_shell_mass</span> <span class="o">&lt;</span> <span class="n">He_shell_min</span><span class="p">:</span>
                <span class="n">TPAGB</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">TPAGB</span>


    <span class="k">def</span> <span class="nf">_PAGB</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">PAGB</span><span class="o">=-</span><span class="mi">1</span>
        <span class="n">core_mass_frac_min</span> <span class="o">=</span> <span class="mf">0.8</span>
        <span class="n">Tc_now</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="n">guess</span><span class="p">]</span>
        <span class="n">Tc_end</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_T&#39;</span><span class="p">][</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="c1">#check for low-inter / high mass split</span>
        <span class="k">if</span> <span class="n">Tc_now</span> <span class="o">&gt;</span> <span class="n">Tc_end</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
                <span class="n">core_mass_frac</span> <span class="o">=</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;c_core_mass&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span><span class="o">/</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;star_mass&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
                <span class="k">if</span> <span class="n">core_mass_frac</span> <span class="o">&gt;</span> <span class="n">core_mass_frac_min</span><span class="p">:</span>
                    <span class="n">PAGB</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>

        <span class="k">return</span> <span class="n">PAGB</span>

    <span class="k">def</span> <span class="nf">_WDCS</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">gamma</span><span class="o">=</span><span class="mf">10.</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">WDCS</span><span class="o">=-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_gamma&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">gamma</span><span class="p">:</span>
                <span class="n">WDCS</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">WDCS</span>

    <span class="k">def</span> <span class="nf">_CBurn</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">,</span><span class="n">XC12</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span><span class="n">guess</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="n">CBURN</span><span class="o">=-</span><span class="mi">1</span>
        <span class="n">XY_min</span><span class="o">=</span><span class="mf">1.0E-6</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">guess</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="n">Xc</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_h1&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
            <span class="n">Yc</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_he4&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
            <span class="n">C12</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;center_c12&#39;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">Xc</span> <span class="o">&lt;</span> <span class="n">XY_min</span> <span class="ow">and</span> <span class="n">Yc</span> <span class="o">&lt;</span> <span class="n">XY_min</span> <span class="ow">and</span> <span class="n">C12</span> <span class="o">&lt;</span> <span class="n">XC12</span><span class="p">:</span>
                <span class="n">CBURN</span><span class="o">=</span><span class="n">i</span><span class="p">;</span> <span class="k">break</span>
        <span class="k">return</span> <span class="n">CBURN</span>

    <span class="c1"># this function computes the distance metric along the evolutionary track</span>
    <span class="c1"># it is made up of several terms whose weights can be adjusted.  Currently</span>
    <span class="c1"># use the H-R and age information only.</span>
    <span class="c1"># other terms can be added, must be &quot;monotonic increasing&quot;</span>
    <span class="k">def</span> <span class="nf">_metric_function</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">tr</span><span class="p">):</span>
        <span class="n">term1</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_Teff&#39;</span><span class="p">]</span>
        <span class="n">term2</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_L&#39;</span><span class="p">]</span>
        <span class="n">term3</span><span class="o">=</span><span class="n">log10</span><span class="p">(</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;star_age&#39;</span><span class="p">])</span>
        <span class="n">term4</span><span class="o">=</span><span class="n">tr</span><span class="p">[</span><span class="s1">&#39;log_center_Rho&#39;</span><span class="p">]</span>
        <span class="n">weight1</span><span class="o">=</span><span class="mf">2.0</span>
        <span class="n">weight2</span><span class="o">=</span><span class="mf">0.125</span>
        <span class="n">weight3</span><span class="o">=</span><span class="mf">1.0</span>
        <span class="n">weight4</span><span class="o">=</span><span class="mf">0.0</span>
        <span class="c1">#etc.</span>

        <span class="n">metric</span><span class="o">=</span><span class="n">zeros</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">))</span>

        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">tr</span><span class="p">)):</span>
            <span class="n">metric</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">metric</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> \
                <span class="n">weight1</span><span class="o">*</span><span class="nb">pow</span><span class="p">(</span><span class="n">term1</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="n">term1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">)</span> <span class="o">+</span> \
                <span class="n">weight2</span><span class="o">*</span><span class="nb">pow</span><span class="p">(</span><span class="n">term2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="n">term2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">)</span> <span class="o">+</span> \
                <span class="n">weight3</span><span class="o">*</span><span class="nb">pow</span><span class="p">(</span><span class="n">term3</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="n">term3</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">)</span> <span class="o">+</span> \
                <span class="n">weight4</span><span class="o">*</span><span class="nb">pow</span><span class="p">(</span><span class="n">term4</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="n">term4</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="mi">2</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">metric</span></div>



<span class="k">if</span> <span class="vm">__name__</span><span class="o">==</span><span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="kn">from</span> <span class="nn">pylab</span> <span class="kn">import</span> <span class="o">*</span>
    <span class="c1"># enter the name (and path to) a MESA history file</span>
    <span class="n">history_file</span><span class="o">=</span><span class="s1">&#39;8M_history.data&#39;</span>

    <span class="c1"># read in the track for comparison purposes</span>
    <span class="n">w</span><span class="o">=</span><span class="n">genfromtxt</span><span class="p">(</span><span class="n">history_file</span><span class="p">,</span> <span class="n">names</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">skip_header</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>

    <span class="c1"># convert the track to EEP assuming a H-ZAMS star of high mass (C-burning) with 100 secondary EEPs per interval</span>
    <span class="n">x</span><span class="o">=</span><span class="n">EEP</span><span class="p">(</span><span class="n">history_file</span><span class="p">,</span> <span class="n">EEP_NAMES</span><span class="o">=</span><span class="n">ZAMShi</span><span class="p">,</span> <span class="n">EEP_INTERVAL</span><span class="o">=</span><span class="mi">100</span><span class="p">)</span>

    <span class="c1"># convert the same track to EEP assumign a He-ZAMS (ignore the main sequence)</span>
    <span class="n">y</span><span class="o">=</span><span class="n">EEP</span><span class="p">(</span><span class="n">history_file</span><span class="p">,</span> <span class="n">EEP_NAMES</span><span class="o">=</span><span class="n">HeZAMS</span><span class="p">,</span> <span class="n">EEP_INTERVAL</span><span class="o">=</span><span class="mi">100</span><span class="p">)</span>

    <span class="c1"># the user can also create their own list of primary EEPs and use that instead.  See the top of this file</span>
    <span class="c1"># for some examples</span>
    
    <span class="c1">#plot the results</span>
    <span class="n">figure</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">plot</span><span class="p">(</span><span class="n">w</span><span class="p">[</span><span class="s1">&#39;log_Teff&#39;</span><span class="p">],</span> <span class="n">w</span><span class="p">[</span><span class="s1">&#39;log_L&#39;</span><span class="p">],</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;DodgerBlue&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;MESA history&#39;</span><span class="p">)</span>
    <span class="n">plot</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="s1">&#39;log_Teff&#39;</span><span class="p">],</span> <span class="n">x</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="s1">&#39;log_L&#39;</span><span class="p">],</span> <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;Tomato&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;EEP from ZAMS&#39;</span><span class="p">)</span>
    <span class="n">plot</span><span class="p">(</span><span class="n">y</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="s1">&#39;log_Teff&#39;</span><span class="p">],</span> <span class="n">y</span><span class="o">.</span><span class="n">eeps</span><span class="p">[</span><span class="s1">&#39;log_L&#39;</span><span class="p">],</span> <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;Lime&#39;</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;EEP from HeZAMS&#39;</span><span class="p">)</span>

    <span class="n">xlim</span><span class="p">(</span><span class="mf">4.5</span><span class="p">,</span><span class="mf">3.5</span><span class="p">)</span>
    <span class="n">legend</span><span class="p">()</span>
    <span class="n">show</span><span class="p">()</span>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>